/**
 * Created by zhoupan on 2015/9/14.
 */
angular.module('author.controller', [])

.controller('AuthorCtrl', ['$scope', '$stateParams', '$ionicHistory', 'load', '$timeout',
        function ($scope, $stateParams, $ionicHistory, load, $timeout) {
            $scope.viewShowState = false;
            $scope.net_error_statue = false;
            $scope.title = "作者详细";
            $scope.authorId = $stateParams.authorId;
            $scope.paperId = $stateParams.paperId;  //页面间传参
            $scope.authorList;
            $scope.back = function () {
                $ionicHistory.goBack(-2);
            };
            $scope.onScholarShow = function (index) {

                if ($scope.authorList[index].scholar.scholarStatue == "1") {

                    $scope.authorList[index].scholar.scholarStatue = "0";
                } else {

                    $scope.authorList[index].scholar.scholarStatue = "1";
                }

            };

            $scope.onScholarInfoShow = function (index) {

                if ($scope.authorList[index].scholar.scholarInfoStatue == "1") {

                    $scope.authorList[index].scholar.scholarInfoStatue = "0";
                } else {

                    $scope.authorList[index].scholar.scholarInfoStatue = "1";
                }

            };

            $scope.onContactWayClick = function (contact_mean, index) {
                if (navigator.intent) {
                    var scholar = $scope.authorList[index];
                    if(contact_mean === 'call' && scholar.mobilePhone != null && scholar.mobilePhone != '') {
                        navigator.intent.contactAuthor({mean: contact_mean, info: {phone: scholar.mobilePhone, callee: scholar.authorName}, isCorrespondingAuthor: false});
                    } else if (contact_mean === 'mail' && scholar.email != null && scholar.email != '') {
                        navigator.intent.contactAuthor({mean: contact_mean, info: {email: scholar.authorID, paperId: $scope.paperId}, isCorrespondingAuthor: false});
                    }
                }
            }

            $scope.onScholarListShow = function (index) {

                if ($scope.authorList[index].scholar.scholarListStatue == "1") {

                    $scope.authorList[index].scholar.scholarListStatue = "0";
                } else {
                    $scope.authorList[index].scholar.scholarListStatue = "1";
                }
            };

            $scope.onExclamatoryMarkTouched = function (tag, e) {
                let instruction = '';
                if (tag === 'tag_index') {
                    e.stopPropagation();
                    instruction = '【学术指数】各项数据均基于当前人员撰写的、同时被CNKI收录的期刊、报纸、会议及专利文献统计而成';
                } else if (tag === 'tag_achieve') {
                    instruction = '【科研成果】主要包括由当前人员撰写的、同时被CNKI收录的期刊、报纸、会议及专利文献信息';
                }
                navigator.intent.showAlert({msg: instruction, tag: '0'});
            };

            $scope.loadMoreContribute = function (authorCode) {
                            if (navigator.intent) {
                                navigator.intent.contributeList(function (json) {},
                                    function (errorMsg) {}, {"authorCode": authorCode});
                            } else {
                                loop();
                            }
                        };
            $scope.loadMoreAchievement = function (authorCode) {
                if (navigator.intent) {
                    navigator.intent.articleList(function (json) {},
                        function (errorMsg) {}, {
                            "authorCode": authorCode
                        });

                } else {
                    loop();
                }
            };
            $scope.readArticle = function (readlink, fn, dbcode) {
                if (navigator.intent) {
                    navigator.intent.readArticle(function (json) {
                            /* body... */

                        },
                        function (errorMsg) {

                        }, {
                            "readlink": readlink,
                            "fn": fn,
                            "dbcode": dbcode
                        });

                } else {
                    loop();

                    //load.hide();
                }
            };
            $scope.loadData = function () {
                load.show("正在加载中...");
                var loop = function () {
                    $timeout(function () {
                            if (navigator.intent) {
                                navigator.intent.authorDetail(function (json) {
                                        /* body... */
                                        load.hide();
                                        $scope.viewShowState = true;
                                        $scope.authorList = window.eval('(' + json + ')').authorList;
                                        //已经正确获取到投稿历史的数据；但是H5中的数据于此不一致，WHY?
                                        console.log('author-list===>'+JSON.stringify($scope.authorList));
                                    },
                                    function (errorMsg) {
                                        load.hide();
                                        $scope.viewShowState = false;
                                        $scope.net_error_statue = true;
                                    }, {
                                        "authorId": $scope.authorId
                                    });
                            } else {
                                loop();
                            }
                        },
                        500);
                };
                loop();
                //}, 2000);
            };
            $scope.loadData();

        }
    ]).controller('MagazineInfotrl',
        function ($scope, $state, $stateParams, $ionicHistory) {
            $scope.title = "稿件详情";
            $scope.data = $stateParams.magazineid;
            $scope.back = function () {
                $ionicHistory.goBack(-2);
            };
        }).controller('FileCtrl',
        function ($scope, $state, $stateParams, $ionicHistory) {
            $scope.title = "稿件详情";
            $scope.fileList = window.eval('(' + $stateParams.fileList + ')').list;
            $scope.type = window.eval('(' + $stateParams.fileList + ')').type;
            $scope.keyWord = window.eval('(' + $stateParams.fileList + ')').keyWord;
            $scope.roleMark = window.eval('(' + $stateParams.fileList + ')').roleMark;

            $scope.back = function () {
                $ionicHistory.goBack(-2);
            };
            $scope.goFileList = function (index) {
                if (navigator.intent) {
                    navigator.intent.magazineReadDownload({
                        "file": $scope.fileList[index].url,
                        "fileType": $scope.fileList[index].fileExtension,
                        "fileName": $scope.type + "" + index,
                        "keyWord": $scope.keyWord,
                        "roleMark": $scope.roleMark,
                        "fileID": $scope.fileList[index].fileID
                    });
                }

            };
        })
        .filter('nbsp_filter', function() {
             return function(text) {
                 return text.replace(new RegExp("&nbsp;","g"), "");
             }
         })
        .controller('FileOnlineCtrl',
        function ($scope, $state, $stateParams, $ionicHistory, $sce) {

            $scope.file = window.eval('(' + $stateParams.file + ')');;

            $scope.targetUrl = $sce.trustAsResourceUrl($scope.file.url);
            $scope.back = function () {
                $ionicHistory.goBack(-1);
            };
            $scope.doRefresh = function () {
                // console.log("ok");
                $timeout(function () {

                        $scope.$broadcast('scroll.refreshComplete');
                    },
                    200);
            };
            //$scope.doRefresh ();
            //iframe.readyState === "complete" || iframe.readyState == "loaded"
            var iframe = document.getElementById('ifrm');
            var emptyImg = document.getElementById('emptyImg');

            if (iframe.attachEvent) {
                iframe.attachEvent("onreadystatechange",
                    function () {
                        //此事件在内容没有被载入时候也会被触发，所以我们要判断状态
                        //有时候会比较怪异 readyState状态会跳过 complete 所以我们loaded状态也要判断
                        if (iframe.readyState === "complete" || iframe.readyState == "loaded") {
                            //代码能执行到这里说明已经载入成功完毕了
                            //要清除掉事件
                            iframe.detachEvent("onreadystatechange", arguments.callee);
                            //这里是回调函数
                        }
                    });
            } else {
                iframe.addEventListener("load",
                    function () {
                        //代码能执行到这里说明已经载入成功完毕了
                        this.removeEventListener("load", arguments.call, false);
                        emptyImg.style.cssText = "display:none";
                        this.style.cssText = "display:''";

                        //这里是回调函数
                    },
                    false);
            }
        })
    .controller('HistoryListCtrl',
        function ($scope, $state, $stateParams, $ionicHistory) {
            // $scope.title = "稿件详情";
            var str =  $stateParams.param; // JSON数组字符串

            var arr = JSON.parse(str);
            var roleMark = arr[arr.length-1].roleMark;
            arr.pop();
            var paramStr = JSON.stringify(arr);

            $scope.targetSelect = 990;
            $scope.editProcess = window.eval('(' + paramStr + ')');

            $scope.onAdviceShow = function (id) {

                <!--2019.11.19若只有一个专家评审内容也予以显示-->
                /*if ($scope.editProcess[id].Process.length == 1) {

                var obj = window.eval('(' + $scope.editProcess[id].Process[0].processDetail + ')');

                var str = JSON.stringify({ dic: $scope.editProcess[id].Process[0].processDetail, historyStage: $scope.editProcess[id].historyStage });
                //navigator.intent.magazineRedOnline({ "file": str, "type": 1 });
                //window.alert(str);
                if (obj.status == "completed") {
                    //var str = JSON.stringify(obj);

                    $state.go('history-detail', { param: str });
                    $scope.closeModal();
                } else if (obj.status == "rejected") {
                    // var str = JSON.stringify({ type: 'rejected', url: url });

                    $state.go('history-detail', { param: str });
                    $scope.closeModal();
                } else {
                    if (navigator.intent) {
                        //var str = JSON.stringify({ name: '稿件原文', url: $scope.data.article.fileList.magazineTextUrl });
                        navigator.intent.magazineRedOnline({ "file": obj.url, "type": 1 });
                    }
                }
            }*/

                if (id == $scope.targetSelect) {
                    $scope.targetSelect = 9999;
                } else {
                    $scope.targetSelect = id;
                    $ionicScrollDelegate.resize();
                }
            };
            $scope.paperDetail = function (param, historyStage) {
                // 需要拿到history-controller中的数据，所以要先接口getHistoryProcessDetail的调用需提前一步
                // history-detail中该接口的调用可以去掉。待做优化。
                console.log("ProcessDetail==>" + JSON.stringify(param));
                var obj = window.eval('(' + param + ')');
                // 需要反复测试详情不存在的判定条件
                if (obj.status == null || obj.status == "") {
                    navigator.intent.showHUD({
                        "msg": "详情不存在"
                    });
                    return;
                }

                var str = JSON.stringify({
                    dic: param,
                    roleMark: roleMark,
                    historyStage: historyStage
                });

                //跳过历史详细直接去阅读文件页面的条件是：下个页面中有且只有一个“查看”
                navigator.intent.historyDetail(function (json) {
                        //load.hide();
                        var see = window.eval('(' + json + ')');
                        var historyList = window.eval('(' + json + ')').pageview;
                        var hasUploadedFile = window.eval('(' + json + ')').hasOwnProperty("UploadFileList");
                        var uploadedFileList = window.eval('(' + json + ')').UploadFileList;

                        var countOfNeedingToView = 0;
                        for (var i = 0; i < historyList.length; i++) {
                            var itemList = historyList[i];
                            for (var j = 0; j < itemList.length; j++) {
                                var item = itemList[j];
                                if (item.saveTable == 'PeerRemarkRec' && item.fieldname == "UploadFile" && (hasUploadedFile && uploadedFileList)) countOfNeedingToView++;
                                if (item.saveTable == 'PeerFormRec' && item.fieldname == "formID") countOfNeedingToView++;
                                if (item.saveTable == 'PeerFormUseWordRec' && item.fieldname == "fileID") countOfNeedingToView++;
                            }
                        }

                        console.log("countOfNeedingToView==" + countOfNeedingToView);
                        /**
                        ** fixed，解决“外审意见附件”不显示的问题
                        ** todo, 解决“评审专家意见”重复显示的问题（原因是，该上传的表格没有上传）
                        **/
                        if (countOfNeedingToView == 1 && navigator.intent) {
                            navigator.intent.magazineRedOnline({
                                "file": obj.url,
                                "type": 1
                            });
                        } else if (obj.status == "completed" || obj.status == "rejected") {
                            console.log('str======>'+str);
                            $state.go('history-detail', {
                                param: str
                            });
                        }
                    },
                    function (errorMsg) {
                        load.hide();
                        //$scope.viewShowState = false;
                        //$scope.net_error_statue = true;
                    }, {
                        "url": param
                    });
                //window.alert(str);
                /*if (obj.status == "completed") {
                // var str = JSON.stringify({ type: 'completed', url: url });

                $state.go('history-detail', { param: str });

            } else if (obj.status == "rejected") {
                // var str = JSON.stringify({ type: 'rejected', url: url });
                $state.go('history-detail', { param: str });

            } else {
                //其他status直接去稿件原文
                if (navigator.intent) {
                    //var str = JSON.stringify({ name: '稿件原文', url: $scope.data.article.fileList.magazineTextUrl });
                    navigator.intent.magazineRedOnline({ "file": obj.url, "type": 1 });
                }
            }*/

            };
            //window.alert($scope.editProcess);
            $scope.back = function () {
                $ionicHistory.goBack(-1);
            };
        });