angular.module('wechat.routes', [])

.config(function($stateProvider, $urlRouterProvider) {

    $stateProvider
        .state("tab", {
            url: "/tab",
            abstract: true,
            templateUrl: "templates/tabs.html",
        })
        .state('tab.message', {
            url: '/message',
            views: {
                'tab-message': {
                    templateUrl: 'templates/tab-message.html',
                    controller: "messageCtrl"
                }
            }
        })
        .state('messageDetail', {
            url: '/messageDetail/:messageId',
            templateUrl: "templates/message-detail.html",
            controller: "messageDetailCtrl"
        })
        .state('tab.friends', {
            url: '/friends',
            views: {
                'tab-friends': {
                    templateUrl: 'templates/tab-friends.html',
                    controller: "friendsCtrl"
                }
            }
        })
        .state('tab.find', {
            url: '/find',
            views: {
                'tab-find': {
                    templateUrl: 'templates/tab-find.html',
                    controller: "findCtrl"
                }
            },
        })
        .state('tab.setting', {
            url: '/setting',
            views: {
                'tab-setting': {
                    templateUrl: 'templates/tab-setting.html',
                    controller: "settingCtrl"
                }
            }
        })
        //magazine-detail
        .state('magazine-detail', {
            url: '/magazine-detail/:jsonStr',
            templateUrl: 'templates/magazine-detail.html',
            controller: 'MagazineCtrl'
        })
        //magazine-detail
        .state('author-detail', {
            url: '/author-detail/:authorId',
            templateUrl: 'templates/author-detail.html',
            controller: 'AuthorCtrl'
        })
        //magazine-detail
        .state('magazine-fileList', {
            url: '/magazine-fileList/:fileList',
            templateUrl: 'templates/magazine-fileList.html',
            controller: 'FileCtrl',
            filter: 'nbsp_filter'
        })
        //magazine-detail
        .state('magazine-info', {
            url: '/magazine-info/:magazineid',
            templateUrl: 'templates/magazine-info.html',
            controller: 'MagazineInfotrl'
        })
        //fileRead-online.html
        .state('fileRead-online', {
            url: '/fileRead-online/:file',
            templateUrl: 'templates/fileRead-online.html',
            controller: 'FileOnlineCtrl'
        })
        .state('history-list', {
            url: '/history-list/:param',
            templateUrl: 'templates/history-list.html',
            controller: 'HistoryListCtrl'
        })
        //历史详细
        .state('history-detail', {
            url: '/history-detail/:param',
            templateUrl: 'templates/history-detail.html',
            controller: 'HistoryCtrl'
        })
       /* .state('upload-image', {
            url: '/upload-image/:data',
            templateUrl: 'templates/upload-image.html',
            controller: 'UploadImageCtrl'
        })*/;

    $urlRouterProvider.otherwise("magazine-detail");
});
