cordova.define("org.apache.cordova.intent", function(require, exports, module) {
    /*
     *
     * Licensed to the Apache Software Foundation (ASF) under one
     * or more contributor license agreements.  See the NOTICE file
     * distributed with this work for additional information
     * regarding copyright ownership.  The ASF licenses this file
     * to you under the Apache License, Version 2.0 (the
     * "License"); you may not use this file except in compliance
     * with the License.  You may obtain a copy of the License at
     *
     *   http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing,
     * software distributed under the License is distributed on an
     * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
     * KIND, either express or implied.  See the License for the
     * specific language governing permissions and limitations
     * under the License.
     *
     */

    var exec = require('cordova/exec');

    /**
     * Provides access to the vibration mechanism on the device.
     */
    module.exports = {
        /**
         * 一共5个参数
           第一个 :成功会掉
           第二个 :失败回调
           第三个 :将要调用的类的配置名字(在config.xml中配置 稍后在下面会讲解)
           第四个 :调用的方法名(一个类里可能有多个方法 靠这个参数区分)
           第五个 :传递的参数  以json的格式
         */
        demo: function(mills) {
            exec(function(winParam) {
                alert(winParam);
            }, null, "AppIntent", "intent", [mills]);
        },
        showAlert: function(message) {
            exec(function(winParam) {

            }, null, "AppIntent", "showAlert", [message]);
        },
        showHUD: function(message) {
            exec(function(winParam) {

            }, null, "AppIntent", "showHUD", [message]);
        },
        expert: function(callfun, message, param2, param3, param4, param5, param6, param7) {
            exec(function(winParam) { callfun(winParam) }, null, "AppIntent", "expert", [message, param2, param3, param4, param5, param6, param7]);
        },
        gotoOperateFee:function(callfun, message) {
            exec(function(winParam) { callfun(winParam) }, null, "AppIntent", "gotoOperateFee", [message]);
        },
        expertOperate: function(callfun, errorCall, message) {
            exec(function(winParam) { callfun(winParam) }, function(winParam) { errorCall(winParam) }, "AppIntent", "expertOperate", [message]);
        },
        back: function() {
            exec(function(winParam) {}, null, "BackNavi", "backNav", []);
        },
        loadData: function(callfun, errorCall, message) {
            exec(function(winParam) { callfun(winParam) }, function(winParam) { errorCall(winParam) }, "AppIntent", "loadData", [message]);
        },
        barcodeScanner: function(callfun, message) {
            exec(function(winParam) { callfun(winParam) }, null, "AppIntent", "barcodeScanner", [message]);
        },
        /* 收藏*/
        magazineFavorite: function(callfun, errorCall, message) {
            exec(function(winParam) { callfun(winParam) }, function(winParam) { errorCall(winParam) }, "AppIntent", "magazineFavorite", [message]);
        },
        /* 取消收藏*/
        magazineFavoriteCancle: function(callfun, errorCall, message) {
            exec(function(winParam) { callfun(winParam) }, function(winParam) { errorCall(winParam) }, "AppIntent", "magazineFavoriteCancle", [message]);
        },
        composition: function(callfun, errorCall, message) {
            exec(function(winParam) { callfun(winParam) }, function(winParam) { errorCall(winParam) }, "AppIntent", "composition", [message]);
        },
        authorDetail: function(callfun, errorCall, message) {
            exec(function(winParam) { callfun(winParam) }, function(winParam) { errorCall(winParam) }, "AppIntent", "authorDetail", [message]);
        },
        /**应该需要请求邮件模板失败的回调**/
        contactAuthor: function(message) {
            exec(null, null, "AppIntent", "contactAuthor", [message]);
        },
        magazineCommit: function(callfun, errorCall, message) {
            exec(function(winParam) { callfun(winParam) }, function(winParam) { errorCall(winParam) }, "AppIntent", "magazineCommit", [message]);
        },
        magazineRedOnline: function(message) {
            exec(null, null, "AppIntent", "magazineRedOnline", [message]);
        },
        magazineReadDownload:function(message) {
            exec(null, null, "AppIntent", "magazineReadDownload", [message]);
        },
        uploadPaperImage: function(callfun, errorCall, message) {
            exec(function(winParam) { callfun(winParam) }, function(winParam) { errorCall(winParam) }, "AppIntent", "uploadPaperImage", [message]);
        },
        deleteImage: function(callfun, errorCall, message) {
            exec(function(winParam) { callfun(winParam) }, function(winParam) { errorCall(winParam) }, "AppIntent", "deleteImage", [message]);
        },
        historyDetail: function(callfun, errorCall, message) {
            exec(function(winParam) { callfun(winParam) }, function(winParam) { errorCall(winParam) }, "AppIntent", "historyDetail", [message]);
        },
        magazineForm: function(callfun, errorCall, message) {
            exec(function(winParam) { callfun(winParam) }, function(winParam) { errorCall(winParam) }, "AppIntent", "magazineForm", [message]);
        },
        magazineFormFromWord: function(callfun, errorCall, message) {
            exec(function(winParam) { callfun(winParam) }, function(winParam) { errorCall(winParam) }, "AppIntent", "magazineFormFromWord", [message]);
        },
        articleList: function(callfun, errorCall, message) {
            exec(function(winParam) { callfun(winParam) }, function(winParam) { errorCall(winParam) }, "AppIntent", "articleList", [message]);
        },
        contributeList: function(callfun, errorCall, message) {
            exec(function(winParam) { callfun(winParam) }, function(winParam) { errorCall(winParam) }, "AppIntent", "contributeList", [message]);
        },
        readArticle: function(callfun, errorCall, message) {
            exec(function(winParam) { callfun(winParam) }, function(winParam) { errorCall(winParam) }, "AppIntent", "readArticle", [message]);
        },
        /*网络首发上传文件*/
        chooseFile:function(callfun, errorCall, message) {
            exec(function(winParam) { callfun(winParam) }, function(winParam) { errorCall(winParam) }, "AppIntent", "chooseFile", [message]);
        },
        /*网络首发上传文件*/
        unpf:function(callfun, errorCall, message) {
            exec(function(winParam) { callfun(winParam) }, function(winParam) { errorCall(winParam) }, "AppIntent", "unpf", [message]);
        },
        expertDetail:function(callfun, errorCall, message) {
            exec(function(winParam) { callfun(winParam) }, function(winParam) { errorCall(winParam) }, "AppIntent", "expertDetail", [message]);
        },
        readFile:function(callfun, errorCall, message) {
            exec(function(winParam) { callfun(winParam) }, function(winParam) { errorCall(winParam) }, "AppIntent", "readFile", [message]);
        },
        netStartFile:function(callfun, errorCall, message) {
            exec(function(winParam) { callfun(winParam) }, function(winParam) { errorCall(winParam) }, "AppIntent", "netStartFile", [message]);
        },
        paperUpload:function(callfun, errorCall, message) {
            exec(function(winParam) { callfun(winParam) }, function(winParam) { errorCall(winParam) }, "AppIntent", "paperUpload", [message]);
        }
    };

});
